<?php

/*
Fotobook Options Panel
*/

// get facebook authorization token
$facebook = new FacebookAPI;

$this_page = $_SERVER['PHP_SELF'].'?page='.$_GET['page'];

// get styles
$styles = fb_get_styles();

// update options if form is submitted
if (isset($_POST['submit'])) {
  fb_options_update_albums_page($_POST['fb_albums_page']);  
  update_option('fb_number_rows', $_POST['fb_number_rows']);
  update_option('fb_style', $_POST['fb_style']);
  if($_POST['fb_number_cols'] != 0) {
    update_option('fb_number_cols', $_POST['fb_number_cols']);
  }
  if(is_numeric($_POST['fb_embedded_width'])) {
    update_option('fb_embedded_width', $_POST['fb_embedded_width']);
  }
  update_option('fb_thumb_size', $_POST['fb_thumb_size']);
  update_option('fb_albums_per_page', $_POST['fb_albums_per_page']);
  if(isset($_POST['fb_album_cmts'])) {
    fb_options_toggle_comments(true);
    update_option('fb_album_cmts', 1);
  } else {
    fb_options_toggle_comments(false);
    update_option('fb_album_cmts', 0);
  }
  foreach($styles as $style) {
    $stylesheet = FB_PLUGIN_PATH.'styles/'.$style.'/style.css';
    if(is_writable($stylesheet)) {
      file_put_contents($stylesheet, $_POST[$style.'_stylesheet']);
    }    
  }
  $sidebar_stylesheet = FB_PLUGIN_PATH.'styles/sidebar-style.css';
  if(is_writable($sidebar_stylesheet)) {
    file_put_contents($sidebar_stylesheet, $_POST['sidebar_stylesheet']);
  }
}

// add a photo album page if there is none
if(get_option('fb_albums_page') == 0) {
  $page = array(
    'post_author'=> 1,
    'post_content'=>'',
    'post_title'=>'Photos',
    'post_name'=>'photos',
    'comment_status'=>1,
    'post_parent'=>0
  );
  // add a photo album page 
  if(get_bloginfo('version') >= 2.1) {  
    $page['post_status'] = 'publish';
    $page['post_type']   = 'page';
  } else {
    $page['post_status'] = 'static';
  }
  $page_id = wp_insert_post($page);
  update_option('fb_albums_page', $page_id);
}

// get options to fill in input fields
$fb_session         = get_option('fb_facebook_session');
$fb_albums_page     = get_option('fb_albums_page');
$fb_number_rows     = get_option('fb_number_rows');
$fb_number_cols     = get_option('fb_number_cols');
$fb_album_cmts      = get_option('fb_album_cmts');
$fb_thumb_size      = get_option('fb_thumb_size');
$fb_albums_per_page = get_option('fb_albums_per_page');
$fb_style           = get_option('fb_style');
$fb_embedded_width  = get_option('fb_embedded_width');

?>             

<style type="text/css">
.wrap .options {
  border: 1px solid #CCCCCC;
  margin-top: 15px;
}
</style>

<?php if($facebook->msg): ?>
<div id="message" class="<?php echo $facebook->error ? 'error' : 'updated' ?> fade"><p><?php echo $facebook->msg ?></p></div>
<?php endif; ?>

<div class="wrap">
  <h2><?php _e('Fotobook Options') ?> <span style="font-size: 11px;"><a href="<?php echo FB_MANAGE_URL ?>">Go to Management &raquo;</a></h2>
  <div style="float: right; background-color: #ccc; width: 200px; padding: 7px; margin-left: 5px; text-align:center">
    <small>A lot of time has gone into this plugin, so if you find it useful don't hesitate to drop me a few bucks.</small>
    <br /><a target="_blank" href="https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&amp;business=aaron%40freshwebs%2enet&amp;item_name=Fotobook%20Donation&amp;buyer_credit_promo_code=&amp;buyer_credit_product_category=&amp;buyer_credit_shipping_method=&amp;buyer_credit_user_address_change=&amp;no_shipping=0&amp;no_note=1&amp;tax=0&amp;currency_code=USD&amp;lc=US&amp;bn=PP%2dDonationsBF&amp;charset=UTF%2d8">
      <img alt="Make payments with PayPal - it's fast, free and secure!" border="0" src="https://www.paypal.com/en_US/i/btn/x-click-but04.gif">
    </a>
  </div>
  <p>This plugin links to your Facebook account and imports all of your albums into a page on your blog. To get 
    started you need to give permission to the plugin to access your Facebook account and then import 
    your albums on the management page.</p>
  <p>Fotobook Links: <a href="http://www.aaronharp.com/dev/wp-fotobook/" target="_blank">Home Page</a> | <a href="http://www.facebook.com/apps/application.php?id=2254862517" target="_blank">Support</a></p>
  	<fieldset class="options">
		<legend><?php _e('Facebook') ?></legend>
    <p>To use this plugin, you must link it to your Facebook account.</p>
    <table class="editform">
      <tr>
        <td valign="top">
          <table>
            <tr>
              <th colspan="2" style="text-align: center"><h3>Add an Account</h3></th>
            </tr>
            <?php if($facebook->token): ?>
            <tr>
              <th scope="row"><?php _e('Step 1') ?></th>
              <td>
                <form method="get" action="http://www.facebook.com/login.php" target="_blank">
                  <input type="hidden" name="api_key" value="<?php echo FB_API_KEY ?>" />
                  <input type="hidden" name="v" value="1.0" />
                  <input type="hidden" name="auth_token" value="<?php echo $facebook->token ?>" />
                  <input type="hidden" name="popup" value="1" />
                  <input type="hidden" name="skipcookie" value="1" />
                  <input type="submit" value="Grant Permissions &gt;" />
                </form>
              </td>
            </tr>
            <tr>
              <th scope="row"><?php _e('Step 2') ?></th>
              <td>
                <form method="get" action="<?php echo $_SERVER['PHP_SELF'] ?>">
                  <input type="hidden" name="page" value="<?php echo $_GET['page'] ?>">
                  <input type="hidden" name="activate-facebook" value="<?php echo $facebook->token ?>" />
                  <input type="submit" value="Apply Permissions &gt;" />
                </form>
              </td>
            </tr>
            <?php else: ?>
            <tr><td colspan="2">Unable to get authorization token.</td></tr>
            <?php endif; ?>
          </table>
        </td>
        <td valign="top">
          <table>
            <tr>
              <th colspan="2" style="text-align: center"><h3>Current Accounts</h3></th>
            </tr>
            <?php 
            if($facebook->link_active()): 
            foreach($facebook->sessions as $key=>$value): 
            ?>
            <tr>
              <td>
                <img src="http://www.facebook.com/favicon.ico" align="absmiddle"> 
                <a href="http://www.facebook.com/profile.php?id=<?php echo $facebook->sessions[$key]['uid'] ?>" target="_blank"><?php echo $facebook->sessions[$key]['name']; ?></a>
              </td>
              <td>
                <form action="<?php echo $_SERVER['PHP_SELF'] ?>" method="get">
                  <input type="hidden" name="deactivate-facebook" value="<?php echo $key ?>">
                  <input type="hidden" name="page" value="<?php echo $_GET['page'] ?>">
                  <input type="submit" value="Remove" onclick="return confirm('Removing an account also removes all of the photos associated with the account.  Would you like to continue?')">
                </form>
              </td>
            </tr>
            <?php endforeach; ?>
            <?php else: ?>
            <tr><td colspan="2">There are currently no active Facebook accounts.</td></tr>
            <?php endif; ?>                            
          </table>
          <?php if($facebook->link_active()): ?>
          <p><small>This plugin has been given access to data from your Facebook account.  You can revoke this access at any<br /> time by clicking remove above or by changing your <a href="http://www.facebook.com/privacy.php?view=platform&tab=ext" target="_blank">privacy</a> settings.</small></p>
          <?php endif; ?>
        </td>
      </tr>
    </table>
    </fieldset>
  
  <form method="post" action="<?php echo $this_page ?>&amp;updated=true">		
  	<fieldset class="options">
		<legend><?php _e('General') ?></legend>
    <table class="editform">
      <tr>
        <th scope="row"><?php _e('Albums Page') ?></th>
        <td>
          <select name="fb_albums_page">
            <?php if(!fb_albums_page_is_set()): ?>
            <option value="0" selected>Please select...</option>
            <?php endif; ?>
            <?php fb_parent_dropdown($fb_albums_page); ?>
          </select>
          <small>Select the page you want to use to display the photo albums.</small>
        </td>
      </tr>
      <tr>
        <th scope="row"><?php _e('Albums Per Page') ?></th>
        <td>
          <input name="fb_albums_per_page" type="text" value="<?php echo $fb_albums_per_page; ?>" size="3" />
          <small><?php _e('Number of albums to display on each page of the main gallery. Set to \'0\' to show all.') ?></small>
        </td>
      </tr>
      <tr>
        <th scope="row"><?php _e('Number of Rows') ?></th>
        <td>
          <input name="fb_number_rows" type="text" value="<?php echo $fb_number_rows; ?>" size="3" />
          <small><?php _e('Set to \'0\' to display all.') ?></small>
        </td>
      </tr>
      <tr>
        <th scope="row"><?php _e('Number of Columns') ?></th>
        <td>
          <input name="fb_number_cols" type="text" value="<?php echo $fb_number_cols; ?>" size="3" />
          <small><?php _e('The number of columns of pictures.') ?></small>
        </td>
      </tr>
      <tr>
        <th scope="row"><?php _e('Display Style') ?></th>
        <td>
          <select name="fb_style">
            <?php foreach($styles as $style): 
            $selected = $style == $fb_style ? ' selected' : null; ?>
            <option value="<?php echo $style ?>"<?php echo $selected; ?>><?php echo $style ?></option>
            <?php endforeach; ?>
          </select>
          <small><?php _e('Select the style you want to use to display the albums.') ?></small>
        </td>
      </tr>
      <tr>
        <th scope="row"><?php _e('Embedded Width') ?></th>
        <td>
          <input name="fb_embedded_width" type="text" value="<?php echo $fb_embedded_width; ?>" size="3" />px
          <small><?php _e('Restrain the width of the embedded photo if it is too wide for your theme.  Set to \'0\' to display the full size.') ?></small>
        </td>
      </tr>
      <tr>
        <th scope="row"><?php _e('Max Thumbnail Size') ?></th>
        <td>
          <input name="fb_thumb_size" type="text" value="<?php echo $fb_thumb_size; ?>" size="3" />px
          <small><?php _e('The maximum size of the thumbnail. The default is 130px.') ?></small>
        </td>
      </tr>
      <tr>
        <th scope="row"><?php _e('Album Commenting') ?></th>
        <td>
          <label><input name="fb_album_cmts" type="checkbox" value="1" <?php if($fb_album_cmts) echo 'checked'; ?> />
          <small><?php _e('Allow commenting on individual albums.  This must be supported by your theme.') ?></small></label>
        </td>
      </tr>
    </table>
    </fieldset>
    <fieldset class="options">
      <legend><?php _e('Stylesheets') ?></legend>
      <div id="fb-stylesheets" class="editform" style="width: 98%">
        <p>Select:
          <select onchange="changeStylesheet(this);">
            <?php 
            $styles[] = 'sidebar';
            foreach($styles as $style): 
            $selected = $style == $fb_style ? ' selected' : null; 
            ?>
            <option value="<?php echo $style ?>"<?php echo $selected; ?>><?php echo $style ?></option>
            <?php endforeach; ?>
          </select>
        </p>
        <?php 
        foreach($styles as $style): 
        $stylesheet = FB_PLUGIN_PATH.'styles/'.$style.'/style.css';
        if($style == 'sidebar') $stylesheet = FB_PLUGIN_PATH.'styles/sidebar-style.css';
        ?>
        <div id="<?php echo $style ?>-stylesheet"<?php echo $style != $fb_style ? ' style="display: none"' : '' ?>>
          <textarea name="<?php echo $style ?>_stylesheet" style="width: 100%; height: 250px"<?php echo is_writable($stylesheet) ? '' : ' disabled="true"' ?>><?php echo file_get_contents($stylesheet) ?></textarea>
          <?php echo is_writable($stylesheet) ? '' : '<em>This file is not writable.</em>' ?>
        </div>
        <?php endforeach; ?>
      </div>
    </fieldset>
    <p class="submit">
      <input type="submit" name="submit" value="<?php _e('Update Options') ?> &raquo;" />
    </p>
      
  </form>
</div> 
